dnl You can probably almost always find Tcl/Tk without any extra flags,
dnl but there are sites which complicate things a little more than
dnl necessary.  Since the developpers of kom++ run on such a machine,
dnl this configuration script is a bit complicated.
dnl
dnl If this fails to find your installation of TCL/TK, please tell
dnl ceder@lysator.liu.se where you store the files, and he will add
dnl a line or three to the loops below.
dnl
define(KOMXX_AC_FIND_TCL,dnl
[AC_SUBST(tcl_includes)
AC_SUBST(tcl_libraries)
AC_CHECKING(for TCL include and library files)
[if test -z "$tcl_includes"; then]
AC_TEST_CPP([#include <tcl.h>],,
  for komxx_ac_dir in               \
    /usr/local/include        \
    /usr/local/gnu/include    \
    /usr/gnu/include          \
    /opt/gnu/include          \
                              \
    /usr/local/tcl7.6/include \
    /usr/local/tcl7.5/include \
    /usr/local/tcl7.4/include \
    /usr/local/tcl7.3/include \
    /usr/local/tcl7.2/include \
    /usr/local/tcl7.1/include \
    /usr/local/tcl7.0/include \
    /usr/local/tcl7/include   \
    /usr/include              \
                              \
    /usr/local/include        \
    /usr/unsupported/include  \
    ; \
  do
    if test -r "$komxx_ac_dir/tcl.h"; then
      if test -z "$tcl_includes"; then
	tcl_includes=-I$komxx_ac_dir
	AC_VERBOSE([setting tcl_includes to $tcl_includes])
      fi
      break
    fi
  done)
[fi]
dnl
dnl Check for the libraries.  First see if replacing the `include' by
dnl `lib' works.
dnl
[if test -z "$tcl_libraries"; then]
AC_HAVE_LIBRARY("itcl",,
for komxx_ac_dir in `echo "$tcl_includes" | sed s/include/lib/` \
    /usr/local/lib        \
    /usr/local/gnu/lib    \
    /usr/gnu/lib          \
    /opt/gnu/lib          \
                          \
    /usr/local/tcl7.6/lib \
    /usr/local/tcl7.5/lib \
    /usr/local/tcl7.4/lib \
    /usr/local/tcl7.3/lib \
    /usr/local/tcl7.2/lib \
    /usr/local/tcl7.1/lib \
    /usr/local/tcl7.0/lib \
    /usr/local/tcl7/lib   \
    /usr/lib              \
                          \
    /usr/local/lib        \
    /usr/unsupported/lib  \
    ; \
do
  for ac_extension in a so sl; do
    if test -r $komxx_ac_dir/libitcl.$ac_extension; then
      if test -z "$tcl_libraries"; then
	tcl_libraries=-L$komxx_ac_dir
	AC_VERBOSE([setting tcl_libraries to $tcl_libraries])
      fi
      break 2
    fi
  done
done)
[fi]])dnl
dnl
dnl Check if a option is acceptable to the C++ compiler in use
dnl
define([KOMXX_AC_CXX_OPTION],
[[komxx_oldflags=$CXXFLAGS
CXXFLAGS="$CXXFLAGS $1"]
AC_COMPILE_CHECK([$1],,,AC_VERBOSE([accepting $1]),
[CXXFLAGS=$komxx_oldflags])])dnl
dnl
