// Higher-level handling of asynchronous messages.
//
// $Id: async_dispatcher.h,v 1.3 1994/08/10 07:18:35 inge Exp $
// Copyright (C) 1994  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef ASYNC_DISPATCHER_
#define ASYNC_DISPATCHER_

#include "async.h"


class Connection;

class Async_text_created;
class Async_text_created_administrator;
typedef void (*Text_created_handlerp)(void *, const Async_text_created&);

class Async_text_message;
class Async_text_message_administrator;
typedef void (*Text_message_handlerp)(void *, const Async_text_message&);


class Async_dispatcher {
  public:
    Async_dispatcher(Connection *);
    ~Async_dispatcher();
    Async_dispatcher &operator=(const Async_dispatcher &);

    void * register_text_created_handler(void *userdata,
					 Text_created_handlerp);
    void * register_text_message_handler(void *userdata,
					 Text_message_handlerp);
    void   unregister_text_created_handler(void *);
    void   unregister_text_message_handler(void *);

    Status handle_async(int this_many = 1);

  private:
    Connection           * port;
    Async_storage        * storage;
    Async_text_created_administrator  * text_created_admin;
    Async_text_message_administrator  * text_message_admin;
};


#endif
