// A Conf-type class.
//
// $Id: conf-type.h,v 1.5 1994/07/16 17:43:32 ceder Exp $
// Copyright (C) 1994  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef CONF_TYPE__
#define CONF_TYPE__

#include "misc.h"
#include "prot-a-LyStr.h"

class prot_a_LyStr;

class Conf_type {
 public:
    friend Conf_type parse_conf_type(prot_a_LyStr &);

    Conf_type();
    Conf_type(const Conf_type&);
    Conf_type(Bool protect,
	      Bool orig,
	      Bool secr,
	      Bool letterbox);

    Conf_type &operator =(const Conf_type &);

    Bool is_protected() const;
    Bool is_original()  const;
    Bool is_secret()    const;
    Bool is_letterbox() const;

 private:
    Bool rd_prot;
    Bool original;
    Bool secret;
    Bool letter_box;
};

Conf_type parse_conf_type(prot_a_LyStr &prot_a_str);
#endif
