// Create-on-demand map of mappings for conferences.
//
// $Id: map-cache.h,v 1.3 1994/07/16 17:44:20 ceder Exp $
// Copyright (C) 1994  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef MAP_CACHE__
#define MAP_CACHE__

#include "kom-types.h"
#include "misc.h"
#include "map-cache.h"
#include "Conf_no.Text_mapping.CHMap.h"

class Map_cache {
  public:
    Map_cache(const Conferences &c);
    Map_cache(const Map_cache&);
    Map_cache& operator=(const Map_cache&);
    ~Map_cache();

    // Methods working on the entire cache:
    void        clear();
    Connection *connection() const;

    // Methods working on individual conf-stats.
    Text_mapping   get(Conf_no cno);

  private:
    class Mtmap : private Conf_noText_mappingCHMap {
      public:
	Bool present(Conf_no p) const;
	Text_mapping &operator[](Conf_no p);
	Mtmap();
    };

    Connection  *m_conn;
    Conf_cache  *m_conf_cache;
    Mtmap        mapmap;
};

#endif
