// Create-on-demand map of mappings for conferences.
//
// $Id: maps.h,v 1.3 1994/07/16 17:44:29 ceder Exp $
// Copyright (C) 1994  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef MAPS__
#define MAPS__

#include "kom-types.h"

class Conferences;
class Conf_cache;
class Connection;
class Map_cache;
class Text_mapping;

class Maps {
  public:
    Maps();
    Maps(const Conferences&);
    ~Maps();

    Maps & operator = (const Maps &);
    void set_conferences(const Conferences&);
    Connection *connection() const;
    
    Text_mapping operator[](Conf_no) const;

    Map_cache * read_map_cache() const;

  private:
    Map_cache *cache;
};
#endif
