// A mark object.
//
// $Id: mark.cc,v 1.3 1994/07/16 17:44:33 ceder Exp $
// Copyright (C) 1994  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "mark.h"

Mark::Mark()
    : text_no(0), mark_type(0)
{
}

Mark::Mark(const Mark &m)
    : text_no(m.text_no), mark_type(m.mark_type)
{
}

const Mark &
Mark::operator =(const Mark &m)
{
    text_no = m.text_no;
    mark_type = m.mark_type;
    return *this;
}


void
Mark::set_textno(Text_no tno)
{
    text_no = tno;
}

void
Mark::set_type(unsigned char type)
{
    mark_type = type;
}


Text_no
Mark::textno()
{
    return text_no;
}

unsigned char
Mark::type()
{
    return mark_type;
}

