// A micro-conf object.
//
// $Id: micro-conf.cc,v 1.3 1994/07/16 17:44:50 ceder Exp $
// Copyright (C) 1994  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "micro-conf.h"

Micro_conf::Micro_conf()
    : conf_no(0), type()
{
}

Micro_conf::Micro_conf(const Micro_conf &m)
    : conf_no(m.conf_no), type(m.type)
{
}

const Micro_conf &
Micro_conf::operator =(const Micro_conf &m)
{
    conf_no = m.conf_no;
    type = m.type;
    return *this;
}


void
Micro_conf::parse_conf_no(prot_a_LyStr &str)
{
    conf_no = str.stol();
}

void
Micro_conf::parse_conf_type(prot_a_LyStr &str)
{
    type = ::parse_conf_type(str); // +++This should be a member function!
}


Conf_no
Micro_conf::confno()
{
    return conf_no;
}
 
Conf_type
Micro_conf::conftype()
{
    return type;
}

