// A micro-conf object.
//
// $Id: micro-conf.h,v 1.3 1994/07/16 17:44:54 ceder Exp $
// Copyright (C) 1994  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef MICRO_CONF__
#define MICRO_CONF__

#include "misc.h"
#include "conf-type.h"
#include "kom-types.h"
#include "prot-a-LyStr.h"


class Micro_conf {
  private:
    Conf_no     conf_no;
    Conf_type   type;

  public:
    Micro_conf();
    Micro_conf(const Micro_conf&);
    const Micro_conf &operator =(const Micro_conf &);

    void parse_conf_no(prot_a_LyStr &str); // +++Error handling??
    void parse_conf_type(prot_a_LyStr &str);

    Conf_no     confno();
    Conf_type   conftype();
};
#endif
