// Information about a server.
//
// $Id: server-info.h,v 1.3 1994/07/16 17:46:19 ceder Exp $
// Copyright (C) 1994  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef SERVER_INFO__
#define SERVER_INFO__

#include "kom-types.h"
#include "prot-a-LyStr.h"


class Server_info {
  private:
	long		version;
	Conf_no		conf_pres_conf; /* Presentation of new confs */
	Conf_no		pers_pres_conf;	/* Presentation of new persons */
	Conf_no		motd_conf; 	/* Conf that receive motds */
	Conf_no		kom_news_conf;  /* News about kom */
	Text_no		motd_of_lyskom; /* To be displayed after login */
	/* and maybe more... */
  public:
    Server_info();
    Server_info(const Server_info&);
    Server_info(prot_a_LyStr &str);
    ~Server_info();
    const Server_info &operator =(const Server_info &);

    long get_version();
    Conf_no   get_conf_pres_conf();
    Conf_no   get_pers_pres_conf();
    Conf_no   get_motd_conf();
    Conf_no   get_kom_news_conf();
    Text_no   get_motd_of_lyskom();
};
#endif
