// nilkom TCL command tables.
//
// $Id: command_table.h,v 1.2 1994/07/27 15:10:39 ceder Exp $
// Copyright (C) 1994  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#ifndef COMMAND_TABLE
#define COMMAND_TABLE

#include <SLList.h>

#include "command_table_entry.h"
#include "LyStr.h"
#include "Tcl_LyStr.h"

class Command_table {
public:
  Command_table();
  ~Command_table();

  Command_table_entry::errcode add_entry(const LyStr & cmd_template,
					 const LyStr & cmd_pretty,
					 const LyStr & tcl_cmd);
  enum matchres {
    NOMATCH,
    UNIQUE,
    AMBIGUOUS
    };
  
  matchres decode_input(const LyStr &user_input, 
			LyStr &tcl_cmd, 
			Tcl_LyStr &alternatives);

  Command_table(const Command_table &);
  Command_table & operator = (const Command_table &);
private:
  SLList<Command_table_entry> entries;
};

#endif
