# A simple kom client for www.
#
# $Id: www.tcl,v 1.6 1994/07/16 16:40:25 inge Exp $
# Copyright (C) 1994  Per Cederqvist and Inge Wallin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


source komlib.tcl

connect kom.lysator.liu.se lyskom

set komfile [open [format "komrc" $env(HOME)]]
gets $komfile persno
gets $komfile passwd
login $persno $passwd invisible
set passwd ""

proc www {textno} {
	print_text $textno
}

# Below: overrides with hyperlink info

proc format_uplink {ulnk} {
	set line [format "<a href=%d>" [uplink parent $ulnk]]
	append line [format "%s till text %d av %s\n" \
		[expr {[uplink is_footnote $ulnk] ? "Fotnot" : "Kommentar"}] \
		[uplink parent $ulnk] \
		[conference name [kom_text author [uplink parent $ulnk]]]]
	append line </a>
	if {[uplink sender $ulnk]} {
		append line [format " S\{nt av %s\n" \
			[conference name [uplink sender $ulnk]]]
	}
	if {[uplink sent_later $ulnk]} {
		append line [format " S\{nt %s\n" \
			[format_date [uplink sent_at $ulnk]]]
	}
	return $line
}

proc format_comment_in {textno gurka} {
	format "<a href=%d>%s i text %d av %s</a>\n" $textno $gurka $textno \
		 [conference name [kom_text author $textno]]
}

proc print_text {text_no} {
	global delim_pre delim_post senaste

	puts <pre>
	puts [format_header $text_no]

	puts {[rende: }
	puts [kom_text subject $text_no]
	puts $delim_pre
	puts </pre>

	puts [kom_text body $text_no]

	puts <pre>
	puts [format "(%d)%s" $text_no $delim_post]
	puts [format_footer $text_no]
	puts </pre>

	set senaste $text_no
}
